// Special version of Windows Classic w/ animated signpost.
// This has been lying around for a while...
SIMPLE_ANIMAL_DEFINITIONS["winclassicplus"] = {
  ["goal"] = {S, S, S, S, T, T, T, T, U, U, U, U, V, V, V, V},
  ["stand"] = {A},
  ["walk"] = {B, B, C, C, D, D, C, C},
  ["run"] = {B, C, D, C},
  ["reverse"] = {B, B, C, C, D, D, C, C},
  ["trick"] = {Z+9, Z+10, Z+11, Z+12, Z+13, Z+14, Z+15, Z+16},
  ["spin"] = {W},
  ["pain"] = {W},
  ["death"] = {Z+17},
  ["squish"] = {X},
  ["ascend"] = {Y},
  ["descend"] = {Z},
  ["glide"] = {Z+1},
  ["drift_left"] = {Z+2, Z+3},
  ["drift_right"] = {Z+2, Z+3},
  ["finished"] = {Z+4, Z+4, Z+4, Z+4, Z+4, Z+4, Z+4, Z+4, Z+4, Z+4,
				  Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5,
				  Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6,
				  Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7,
                  Z+8, Z+8, Z+8, Z+8, Z+8, Z+8, Z+8, Z+8, Z+8, Z+8,
				  Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7,
				  Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6,
				  Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5, Z+5},
  ["goalspecial"] = {Z+18, Z+18, Z+18, Z+19, Z+19, Z+19, Z+20, Z+20, Z+20, Z+21, Z+21, Z+21, Z+22, Z+22, Z+22,
					 Z+23, Z+23, Z+23, Z+24, Z+24, Z+24, Z+25, Z+25, Z+25, Z+26, Z+26, Z+26, Z+27, Z+27, Z+27,
					 Z+26, Z+26, Z+26, Z+25, Z+25, Z+25, Z+24, Z+24, Z+24, Z+23, Z+23, Z+23, Z+22, Z+22, Z+22,
					 Z+21, Z+21, Z+21, Z+20, Z+20, Z+20, Z+19, Z+19, Z+19}
}

// Flight... progress, my friend!
function SIMPLE_ANIMAL_HELPERS.isGliding(mobj)
  return mobj.paragliding
end

function SIMPLE_ANIMAL_HOOKS.startmeup(mobj, sequences)
  local helpers = _G["SIMPLE_ANIMAL_HELPERS"]
  if helpers.getSkin(mobj) == "winclassicplus"
	
    for i = 0,108 do
      S_StopSoundByID(mobj, sfx_krta00 + i)
    end
	
    if (sequences[1] == "goal")
	  if helpers.getPlayer(mobj).kartstuff[k_position] == 1 and helpers.isFinished(mobj)
	    return "goalspecial"
	  else
        return
	  end
	elseif helpers.getPlayer(mobj).playerstate == PST_DEAD
	  helpers.getPlayer(mobj).hastricked = false
	  return "death"
	elseif helpers.isCountdownCharging(mobj)
      return "walk"
	elseif ((helpers.getPlayer(mobj).hastricked) or helpers.isTricking(mobj)) and (helpers.getPlayer(mobj).spintimer > 0 or helpers.isSpringing(mobj))
	and helpers.getPlayer(mobj).playerstate == PST_LIVE and not (helpers.isRespawning(mobj) or helpers.getPlayer(mobj).kartstuff[k_dropdash] > 0)
	  return "trick"
    elseif helpers.isAirborne(mobj) and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj))
      if helpers.isGliding(mobj) and not helpers.isTricking(mobj)
        return "glide"
      elseif helpers.isAscending(mobj) and not helpers.isTricking(mobj)
        return "ascend"
      else
        return "descend"
      end
    elseif (helpers.isWalkSpeed(mobj) and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj)))
	  -- Hack to slow down the walking animation at low speeds.
	  local halfspeed = helpers.isWalkSpeedMultiplied(mobj, FRACUNIT/2)
	  local quarterspeed = helpers.isWalkSpeedMultiplied(mobj, FRACUNIT/4)
      if (helpers.isMovingBackward(mobj) and not helpers.isAirborne(mobj))
        if ((not quarterspeed and leveltime%4 < 3) or (quarterspeed and not halfspeed) and leveltime%2 < 1)
          mobj.Simple_AnimaL_timer = $ - 1
        end
        return "reverse"
      elseif ((not quarterspeed and leveltime%4 < 3) or (quarterspeed and not halfspeed) and leveltime%2 < 1)
        mobj.Simple_AnimaL_timer = $ - 1
        return
      end
	elseif (string.sub(sequences[1], 1, 3) == "run") and not helpers.isWalkSpeedMultiplied(mobj, 5*FRACUNIT/2) then
	  return "walk"
    elseif helpers.isNoSpeed(mobj) and helpers.isFinished(mobj)
	and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj))
      return "finished"
    end
  end
end